
EnableExplicit

;Nautilus Engine Demo
;Version: 1.00

;Tutorial 2
;The Screen (render surface)

XIncludeFile "nautilus.pbi"

Procedure.i Main()
  
  ;we will cover following interface functions & structures :)
  
;   Interface NE_ENGINE
;     WindowSize.i(*Out)
;     WindowCenter.i(*Out)
;     WindowOrigin.i(*Out)
;     ;...
;     ScreenSize.i(*Out)
;     ScreenCenter.i(*Out)
;     ScreenFactor.i(*Out)
;     ScreenResize.i(Width.i,Height.i)
;     ScreenResetSize.i()
;     ;... 
;     RenderColor.i(Color.l = #Null)
;     RenderBegin.i(*Delta = #Null,*FPS = #Null,*Error = #Null)
;     RenderEnd.i()
;     ;...
;   EndInterface
  
;   Structure NE_VECTOR_STRUCT
;     x.f
;     y.f
;   EndStructure
  
  ;ok lets create a qwindow and initialize the engine:
  
  Protected *engine.NE_ENGINE
  Protected engine_fps.i
  Protected engine_delta.f
  Protected engine_error.i
  
  Protected window_size.NE_VECTOR_STRUCT
  Protected window_center.NE_VECTOR_STRUCT
  Protected window_origin.RECT
  
  Protected screen_size.NE_VECTOR_STRUCT
  Protected screen_center.NE_VECTOR_STRUCT
  Protected screen_factor.NE_VECTOR_STRUCT
  
  *engine = nautilusWindow("Tutorial 2: The Screen",800,600,#NE_WINDOW_NORMAL,320,200,60)
  If *engine
    
    ;set the window icon:
    
    nautilusWindowIcon(*engine,?icon)
    
    ;window interface functions: 
    
    *engine\WindowSize(@window_size)
    *engine\WindowCenter(@window_center)
    *engine\WindowOrigin(@window_origin)
    
    Debug window_size\x
    Debug window_size\y
    
    Debug window_center\x
    Debug window_center\y
    
    Debug window_origin\left
    Debug window_origin\top
    
    Debug "--------------"

    ;---------------------------------------------------------
    
    ;we can also get some informations about the screen
    
    *engine\ScreenSize(@screen_size)
    *engine\ScreenCenter(@screen_center)
    *engine\ScreenFactor(@screen_factor);<- screen vs. window
    
    Debug screen_size\x
    Debug screen_size\y
    
    Debug screen_center\x
    Debug screen_center\y
    
    Debug screen_factor\x
    Debug screen_factor\y
    
    Debug "--------------"
    
    ;---------------------------------------------------------
    
    *engine\ScreenResize(800,600);<- lets change the screen size to 800,600
    
    *engine\ScreenSize(@screen_size)
    *engine\ScreenCenter(@screen_center)
    *engine\ScreenFactor(@screen_factor);<- screen vs. window
    
    Debug screen_size\x
    Debug screen_size\y
    
    Debug screen_center\x
    Debug screen_center\y
    
    Debug screen_factor\x
    Debug screen_factor\y
    
    Debug "--------------"
    
    *engine\ScreenResetSize();<- revert back to the original screen size

    *engine\ScreenSize(@screen_size)
    *engine\ScreenCenter(@screen_center)
    *engine\ScreenFactor(@screen_factor);<- screen vs. window
    
    Debug screen_size\x
    Debug screen_size\y
    
    Debug screen_center\x
    Debug screen_center\y
    
    Debug screen_factor\x
    Debug screen_factor\y
    
    ;---------------------------------------------------------
    
    *engine\RenderColor($6BC89E);lets set the render background color to something green
    
    Repeat
      If *engine\RenderBegin(@engine_delta,@engine_fps);<- all rendering needs to occur between RenderBegin() & RenderEnd()!
                                                                  ;RenderBegin() returns the deltatime and fps

      ;if nothing is rendered all you will see is a black Screen (or a empty Screen with the color set by RenderColor())
        *engine\RenderEnd()    
      EndIf

    Until nautilusWindowExit()                      
    nautilusWindowClose(*engine)
  EndIf 
  
  
  ProcedureReturn #Null
EndProcedure

Main()

End

DataSection
  icon:
  IncludeBinary "ne.ico"
EndDataSection

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 139
; FirstLine = 122
; Folding = -
; EnableXP