
EnableExplicit

;Nautilus Engine Demo
;Version: 1.00

;Tutorial 3
;Drawing Primitives

XIncludeFile "nautilus.pbi"

Procedure.i Main()
  Protected *engine.NE_ENGINE
  If nautilusVersion() = #NE_VERSION

;     Interface NE_ENGINE
;       ;...
;       DrawPointSize.i(Size.f = 1)
;       DrawLineSize.i(Size.f = 1)
;       DrawPoint.i(X.f,Y.f,Color.l = $FFFFFFFF)
;       DrawLine.i(X1.f,Y1.f,X2.f,Y2.f,Color.l = $FFFFFFFF)
;       DrawTriangle.i(X.f,Y.f,Width.f,Height.f,Fill.b = #False,Color.l = $FFFFFFFF)
;       DrawBox.i(X.f,Y.f,Width.f,Height.f,Center.b = #False,Fill.b = #False,Color.l = $FFFFFFFF)
;       DrawDiamond.i(X.f,Y.f,Width.f,Height.f,Center.b = #False,Fill.b = #False,Color.l = $FFFFFFFF)
;       DrawCircle.i(X.f,Y.f,Radius.f,Fill.b = #False,Color.l = $FFFFFFFF)
;     EndInterface
    
    *engine = nautilusWindow("Tutorial 3: Drawing Primitives",800,600,#NE_WINDOW_NORMAL,320,200,60)
    If *engine
      Repeat
        If *engine\RenderBegin()
          
          ;draw a point:
          *engine\DrawPointSize(10);change the point size (note that a point is defined as pixel so it will expand as square!)
          *engine\DrawPoint(10,10,$FF0000FF);draw a red point
          
          ;draw a line:
          *engine\DrawLineSize(4);change size
          *engine\DrawLine(10,10,310,190);draw a line (the default color is white if no color is supplied!)
          
          ;draw a triangle:
          *engine\DrawLineSize(1);change size
          *engine\DrawTriangle(100,100,50,50,#False)
          *engine\DrawTriangle(110,110,50,50,#True,$A571DB3F);a triangle can also be filled (transparence can be set within the color!)
          
          ;draw a box:
          *engine\DrawBox(160,100,200,100,#True);a box can be center oriented!
          *engine\DrawBox(160,100,20,10,#False,#True,$DB71903F)
          
          ;draw a diamond:
          *engine\DrawDiamond(200,50,64,32,#True,#True);this might be helpful for isometric experiments
          
          ;draw a circle:
          *engine\DrawCircle(200,100,80)
          
          *engine\RenderEnd()
        EndIf
      Until nautilusWindowExit()
      nautilusWindowClose(*engine)
    EndIf 
  EndIf
  ProcedureReturn #Null
EndProcedure

Main()

End

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 37
; FirstLine = 14
; Folding = -
; EnableXP